/* ***********************************************************
 * This file was automatically generated on 2019-09-24.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 16-channel digital input/output
 */
public class BrickletIO16 extends Device {
	public final static int DEVICE_IDENTIFIER = 28;
	public final static String DEVICE_DISPLAY_NAME = "IO-16 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "io16", DEVICE_IDENTIFIER, BrickletIO16.class);

	public final static byte FUNCTION_SET_PORT = (byte)1;
	public final static byte FUNCTION_GET_PORT = (byte)2;
	public final static byte FUNCTION_SET_PORT_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_GET_PORT_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)5;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_SET_PORT_INTERRUPT = (byte)7;
	public final static byte FUNCTION_GET_PORT_INTERRUPT = (byte)8;
	public final static byte FUNCTION_SET_PORT_MONOFLOP = (byte)10;
	public final static byte FUNCTION_GET_PORT_MONOFLOP = (byte)11;
	public final static byte FUNCTION_SET_SELECTED_VALUES = (byte)13;
	public final static byte FUNCTION_GET_EDGE_COUNT = (byte)14;
	public final static byte FUNCTION_SET_EDGE_COUNT_CONFIG = (byte)15;
	public final static byte FUNCTION_GET_EDGE_COUNT_CONFIG = (byte)16;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_INTERRUPT = 9;
	private final static int CALLBACK_MONOFLOP_DONE = 12;

	public final static char DIRECTION_IN = 'i';
	public final static char DIRECTION_OUT = 'o';
	public final static short EDGE_TYPE_RISING = (short)0;
	public final static short EDGE_TYPE_FALLING = (short)1;
	public final static short EDGE_TYPE_BOTH = (short)2;

	private List<InterruptListener> listenerInterrupt = new CopyOnWriteArrayList<InterruptListener>();
	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class PortConfiguration {
		public short directionMask;
		public short valueMask;

		public String toString() {
			return "[" + "directionMask = " + directionMask + ", " + "valueMask = " + valueMask + "]";
		}
	}

	public class PortMonoflop {
		public short value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	public class EdgeCountConfig {
		public short edgeType;
		public short debounce;

		public String toString() {
			return "[" + "edgeType = " + edgeType + ", " + "debounce = " + debounce + "]";
		}
	}

	/**
	 * This listener is triggered whenever a change of the voltage level is detected
	 * on pins where the interrupt was activated with {@link BrickletIO16#setPortInterrupt(char, short)}.
	 * 
	 * The values are the port, a bitmask that specifies which interrupts occurred
	 * and the current value bitmask of the port.
	 * 
	 * For example:
	 * 
	 * * ('a', 1, 1) or ('a', 0b00000001, 0b00000001) means that on port A an
	 *   interrupt on pin 0 occurred and currently pin 0 is high and pins 1-7 are low.
	 * * ('b', 129, 254) or ('b', 0b10000001, 0b11111110) means that on port B
	 *   interrupts on pins 0 and 7 occurred and currently pin 0 is low and pins 1-7
	 *   are high.
	 */
	public interface InterruptListener extends DeviceListener {
		public void interrupt(char port, short interruptMask, short valueMask);
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the port, the involved pins and the current value of
	 * the pins (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(char port, short selectionMask, short valueMask);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIO16(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PORT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PORT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PORT_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PORT_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PORT_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PORT_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PORT_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PORT_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUES)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_INTERRUPT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				char port = (char)(bb.get());
				short interruptMask = IPConnection.unsignedByte(bb.get());
				short valueMask = IPConnection.unsignedByte(bb.get());

				for (InterruptListener listener: listenerInterrupt) {
					listener.interrupt(port, interruptMask, valueMask);
				}
			}
		};

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				char port = (char)(bb.get());
				short selectionMask = IPConnection.unsignedByte(bb.get());
				short valueMask = IPConnection.unsignedByte(bb.get());

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(port, selectionMask, valueMask);
				}
			}
		};
	}

	/**
	 * Sets the output value (high or low) for a port ("a" or "b") with a bitmask
	 * (8bit). A 1 in the bitmask means high and a 0 in the bitmask means low.
	 * 
	 * For example: The value 15 or 0b00001111 will turn the pins 0-3 high and the
	 * pins 4-7 low for the specified port.
	 * 
	 * All running monoflop timers of the given port will be aborted if this function
	 * is called.
	 * 
	 * \note
	 *  This function does nothing for pins that are configured as input.
	 *  Pull-up resistors can be switched on with {@link BrickletIO16#setPortConfiguration(char, short, char, boolean)}.
	 */
	public void setPort(char port, short valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_PORT, this);

		bb.put((byte)port);
		bb.put((byte)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns a bitmask of the values that are currently measured on the
	 * specified port. This function works if the pin is configured to input
	 * as well as if it is configured to output.
	 */
	public short getPort(char port) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PORT, this);

		bb.put((byte)port);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short valueMask = IPConnection.unsignedByte(bb.get());

		return valueMask;
	}

	/**
	 * Configures the value and direction of a specified port. Possible directions
	 * are 'i' and 'o' for input and output.
	 * 
	 * If the direction is configured as output, the value is either high or low
	 * (set as *true* or *false*).
	 * 
	 * If the direction is configured as input, the value is either pull-up or
	 * default (set as *true* or *false*).
	 * 
	 * For example:
	 * 
	 * * ('a', 255, 'i', true) or ('a', 0b11111111, 'i', true) will set all pins of port A as input pull-up.
	 * * ('a', 128, 'i', false) or ('a', 0b10000000, 'i', false) will set pin 7 of port A as input default (floating if nothing is connected).
	 * * ('b', 3, 'o', false) or ('b', 0b00000011, 'o', false) will set pins 0 and 1 of port B as output low.
	 * * ('b', 4, 'o', true) or ('b', 0b00000100, 'o', true) will set pin 2 of port B as output high.
	 * 
	 * Running monoflop timers for the selected pins will be aborted if this
	 * function is called.
	 * 
	 * The default configuration is input with pull-up.
	 */
	public void setPortConfiguration(char port, short selectionMask, char direction, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_PORT_CONFIGURATION, this);

		bb.put((byte)port);
		bb.put((byte)selectionMask);
		bb.put((byte)direction);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns a direction bitmask and a value bitmask for the specified port. A 1 in
	 * the direction bitmask means input and a 0 in the bitmask means output.
	 * 
	 * For example: A return value of (15, 51) or (0b00001111, 0b00110011) for
	 * direction and value means that:
	 * 
	 * * pins 0 and 1 are configured as input pull-up,
	 * * pins 2 and 3 are configured as input default,
	 * * pins 4 and 5 are configured as output high
	 * * and pins 6 and 7 are configured as output low.
	 */
	public PortConfiguration getPortConfiguration(char port) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PORT_CONFIGURATION, this);

		bb.put((byte)port);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PortConfiguration obj = new PortConfiguration();
		obj.directionMask = IPConnection.unsignedByte(bb.get());
		obj.valueMask = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Sets the debounce period of the {@link BrickletIO16.InterruptListener} listener in ms.
	 * 
	 * For example: If you set this value to 100, you will get the interrupt
	 * maximal every 100ms. This is necessary if something that bounces is
	 * connected to the IO-16 Bricklet, such as a button.
	 * 
	 * The default value is 100.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletIO16#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Sets the pins on which an interrupt is activated with a bitmask.
	 * Interrupts are triggered on changes of the voltage level of the pin,
	 * i.e. changes from high to low and low to high.
	 * 
	 * For example: ('a', 129) or ('a', 0b10000001) will enable the interrupt for
	 * pins 0 and 7 of port a.
	 * 
	 * The interrupt is delivered with the {@link BrickletIO16.InterruptListener} listener.
	 */
	public void setPortInterrupt(char port, short interruptMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_PORT_INTERRUPT, this);

		bb.put((byte)port);
		bb.put((byte)interruptMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the interrupt bitmask for the specified port as set by
	 * {@link BrickletIO16#setPortInterrupt(char, short)}.
	 */
	public short getPortInterrupt(char port) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PORT_INTERRUPT, this);

		bb.put((byte)port);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short interruptMask = IPConnection.unsignedByte(bb.get());

		return interruptMask;
	}

	/**
	 * Configures a monoflop of the pins specified by the second parameter as 8 bit
	 * long bitmask. The specified pins must be configured for output. Non-output
	 * pins will be ignored.
	 * 
	 * The third parameter is a bitmask with the desired value of the specified
	 * output pins. A 1 in the bitmask means high and a 0 in the bitmask means low.
	 * 
	 * The forth parameter indicates the time (in ms) that the pins should hold
	 * the value.
	 * 
	 * If this function is called with the parameters ('a', 9, 1, 1500) or
	 * ('a', 0b00001001, 0b00000001, 1500): Pin 0 will get high and pin 3 will get
	 * low on port 'a'. In 1.5s pin 0 will get low and pin 3 will get high again.
	 * 
	 * A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
	 * have a RS485 bus and an IO-16 Bricklet connected to one of the slave
	 * stacks. You can now call this function every second, with a time parameter
	 * of two seconds and pin 0 set to high. Pin 0 will be high all the time. If now
	 * the RS485 connection is lost, then pin 0 will get low in at most two seconds.
	 */
	public void setPortMonoflop(char port, short selectionMask, short valueMask, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)15, FUNCTION_SET_PORT_MONOFLOP, this);

		bb.put((byte)port);
		bb.put((byte)selectionMask);
		bb.put((byte)valueMask);
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given pin) the current value and the time as set by
	 * {@link BrickletIO16#setPortMonoflop(char, short, short, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public PortMonoflop getPortMonoflop(char port, short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_GET_PORT_MONOFLOP, this);

		bb.put((byte)port);
		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PortMonoflop obj = new PortMonoflop();
		obj.value = IPConnection.unsignedByte(bb.get());
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the output value (high or low) for a port ("a" or "b" with a bitmask,
	 * according to the selection mask. The bitmask is 8 bit long and a 1 in the
	 * bitmask means high and a 0 in the bitmask means low.
	 * 
	 * For example: The parameters ('a', 192, 128) or ('a', 0b11000000, 0b10000000)
	 * will turn pin 7 high and pin 6 low on port A, pins 0-6 will remain untouched.
	 * 
	 * Running monoflop timers for the selected pins will be aborted if this
	 * function is called.
	 * 
	 * \note
	 *  This function does nothing for pins that are configured as input.
	 *  Pull-up resistors can be switched on with {@link BrickletIO16#setPortConfiguration(char, short, char, boolean)}.
	 */
	public void setSelectedValues(char port, short selectionMask, short valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_SELECTED_VALUES, this);

		bb.put((byte)port);
		bb.put((byte)selectionMask);
		bb.put((byte)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current value of the edge counter for the selected pin on port A.
	 * You can configure the edges that are counted with {@link BrickletIO16#setEdgeCountConfig(short, short, short)}.
	 * 
	 * If you set the reset counter to *true*, the count is set back to 0
	 * directly after it is read.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public long getEdgeCount(short pin, boolean resetCounter) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_GET_EDGE_COUNT, this);

		bb.put((byte)pin);
		bb.put((byte)(resetCounter ? 1 : 0));

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long count = IPConnection.unsignedInt(bb.getInt());

		return count;
	}

	/**
	 * Configures the edge counter for the selected pin of port A. Pins 0 and 1
	 * are available for edge counting.
	 * 
	 * The edge type parameter configures if rising edges, falling edges or
	 * both are counted if the pin is configured for input. Possible edge types are:
	 * 
	 * * 0 = rising (default)
	 * * 1 = falling
	 * * 2 = both
	 * 
	 * The debounce time is given in ms.
	 * 
	 * Configuring an edge counter resets its value to 0.
	 * 
	 * If you don't know what any of this means, just leave it at default. The
	 * default configuration is very likely OK for you.
	 * 
	 * Default values: 0 (edge type) and 100ms (debounce time)
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public void setEdgeCountConfig(short pin, short edgeType, short debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_EDGE_COUNT_CONFIG, this);

		bb.put((byte)pin);
		bb.put((byte)edgeType);
		bb.put((byte)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the edge type and debounce time for the selected pin of port A as set by
	 * {@link BrickletIO16#setEdgeCountConfig(short, short, short)}.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public EdgeCountConfig getEdgeCountConfig(short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_EDGE_COUNT_CONFIG, this);

		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		EdgeCountConfig obj = new EdgeCountConfig();
		obj.edgeType = IPConnection.unsignedByte(bb.get());
		obj.debounce = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Interrupt listener.
	 */
	public void addInterruptListener(InterruptListener listener) {
		listenerInterrupt.add(listener);
	}

	/**
	 * Removes a Interrupt listener.
	 */
	public void removeInterruptListener(InterruptListener listener) {
		listenerInterrupt.remove(listener);
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIO16.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIO16.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 0)) > 0) {updateStateFn.accept("IO16InputPin0", transformIO16InputPin0Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 1)) > 0) {updateStateFn.accept("IO16InputPin1", transformIO16InputPin1Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 2)) > 0) {updateStateFn.accept("IO16InputPin2", transformIO16InputPin2Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 3)) > 0) {updateStateFn.accept("IO16InputPin3", transformIO16InputPin3Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 4)) > 0) {updateStateFn.accept("IO16InputPin4", transformIO16InputPin4Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 5)) > 0) {updateStateFn.accept("IO16InputPin5", transformIO16InputPin5Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 6)) > 0) {updateStateFn.accept("IO16InputPin6", transformIO16InputPin6Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 7)) > 0) {updateStateFn.accept("IO16InputPin7", transformIO16InputPin7Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 0)) > 0) {updateStateFn.accept("IO16InputPin8", transformIO16InputPin8Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 1)) > 0) {updateStateFn.accept("IO16InputPin9", transformIO16InputPin9Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 2)) > 0) {updateStateFn.accept("IO16InputPin10", transformIO16InputPin10Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 3)) > 0) {updateStateFn.accept("IO16InputPin11", transformIO16InputPin11Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 4)) > 0) {updateStateFn.accept("IO16InputPin12", transformIO16InputPin12Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 5)) > 0) {updateStateFn.accept("IO16InputPin13", transformIO16InputPin13Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 6)) > 0) {updateStateFn.accept("IO16InputPin14", transformIO16InputPin14Callback0(port, interruptMask, valueMask, cfg));}});
		this.addInterruptListener((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 7)) > 0) {updateStateFn.accept("IO16InputPin15", transformIO16InputPin15Callback0(port, interruptMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 0)) > 0) {updateStateFn.accept("IO16OutputPin0", transformIO16OutputPin0Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 1)) > 0) {updateStateFn.accept("IO16OutputPin1", transformIO16OutputPin1Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 2)) > 0) {updateStateFn.accept("IO16OutputPin2", transformIO16OutputPin2Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 3)) > 0) {updateStateFn.accept("IO16OutputPin3", transformIO16OutputPin3Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 4)) > 0) {updateStateFn.accept("IO16OutputPin4", transformIO16OutputPin4Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 5)) > 0) {updateStateFn.accept("IO16OutputPin5", transformIO16OutputPin5Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 6)) > 0) {updateStateFn.accept("IO16OutputPin6", transformIO16OutputPin6Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 7)) > 0) {updateStateFn.accept("IO16OutputPin7", transformIO16OutputPin7Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 0)) > 0) {updateStateFn.accept("IO16OutputPin8", transformIO16OutputPin8Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 1)) > 0) {updateStateFn.accept("IO16OutputPin9", transformIO16OutputPin9Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 2)) > 0) {updateStateFn.accept("IO16OutputPin10", transformIO16OutputPin10Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 3)) > 0) {updateStateFn.accept("IO16OutputPin11", transformIO16OutputPin11Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 4)) > 0) {updateStateFn.accept("IO16OutputPin12", transformIO16OutputPin12Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 5)) > 0) {updateStateFn.accept("IO16OutputPin13", transformIO16OutputPin13Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 6)) > 0) {updateStateFn.accept("IO16OutputPin14", transformIO16OutputPin14Callback0(port, selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 7)) > 0) {updateStateFn.accept("IO16OutputPin15", transformIO16OutputPin15Callback0(port, selectionMask, valueMask, cfg));}});
        
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin0").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 0), 'i', cfg.pinConfiguration0 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 0)));
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin1").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 1), 'i', cfg.pinConfiguration1 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 1)));
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin2").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 2), 'i', cfg.pinConfiguration2 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 2)));
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin3").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 3), 'i', cfg.pinConfiguration3 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 3)));
		}
		if (cfg.pinConfiguration4 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin4").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 4), 'i', cfg.pinConfiguration4 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 4)));
		}
		if (cfg.pinConfiguration5 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin5").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 5), 'i', cfg.pinConfiguration5 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 5)));
		}
		if (cfg.pinConfiguration6 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin6").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 6), 'i', cfg.pinConfiguration6 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 6)));
		}
		if (cfg.pinConfiguration7 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin7").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 7), 'i', cfg.pinConfiguration7 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 7)));
		}
		if (cfg.pinConfiguration8 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin8").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 0), 'i', cfg.pinConfiguration8 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 0)));
		}
		if (cfg.pinConfiguration9 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin9").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 1), 'i', cfg.pinConfiguration9 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 1)));
		}
		if (cfg.pinConfiguration10 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin10").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 2), 'i', cfg.pinConfiguration10 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 2)));
		}
		if (cfg.pinConfiguration11 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin11").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 3), 'i', cfg.pinConfiguration11 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 3)));
		}
		if (cfg.pinConfiguration12 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin12").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 4), 'i', cfg.pinConfiguration12 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 4)));
		}
		if (cfg.pinConfiguration13 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin13").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 5), 'i', cfg.pinConfiguration13 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 5)));
		}
		if (cfg.pinConfiguration14 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin14").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 6), 'i', cfg.pinConfiguration14 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 6)));
		}
		if (cfg.pinConfiguration15 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("IO16InputPin15").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 7), 'i', cfg.pinConfiguration15 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 7)));
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin0").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 0), 'o', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin1").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 1), 'o', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin2").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 2), 'o', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin3").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 3), 'o', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration4 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin4").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 4), 'o', cfg.pinConfiguration4 % 2 == 1);
		}
		if (cfg.pinConfiguration5 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin5").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 5), 'o', cfg.pinConfiguration5 % 2 == 1);
		}
		if (cfg.pinConfiguration6 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin6").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 6), 'o', cfg.pinConfiguration6 % 2 == 1);
		}
		if (cfg.pinConfiguration7 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin7").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 7), 'o', cfg.pinConfiguration7 % 2 == 1);
		}
		if (cfg.pinConfiguration8 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin8").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 0), 'o', cfg.pinConfiguration8 % 2 == 1);
		}
		if (cfg.pinConfiguration9 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin9").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 1), 'o', cfg.pinConfiguration9 % 2 == 1);
		}
		if (cfg.pinConfiguration10 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin10").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 2), 'o', cfg.pinConfiguration10 % 2 == 1);
		}
		if (cfg.pinConfiguration11 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin11").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 3), 'o', cfg.pinConfiguration11 % 2 == 1);
		}
		if (cfg.pinConfiguration12 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin12").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 4), 'o', cfg.pinConfiguration12 % 2 == 1);
		}
		if (cfg.pinConfiguration13 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin13").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 5), 'o', cfg.pinConfiguration13 % 2 == 1);
		}
		if (cfg.pinConfiguration14 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin14").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 6), 'o', cfg.pinConfiguration14 % 2 == 1);
		}
		if (cfg.pinConfiguration15 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("IO16OutputPin15").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 7), 'o', cfg.pinConfiguration15 % 2 == 1);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin0").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin1").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin2").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin3").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration4 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin4").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration5 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin5").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration6 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin6").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration7 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin7").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration8 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin8").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration9 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin9").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration10 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin10").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration11 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin11").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration12 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin12").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration13 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin13").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration14 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin14").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration15 <= 1) {
		BrickletIO16MonoflopConfig channelCfg = getChannelConfigFn.apply("IO16MonoflopPin15").as(BrickletIO16MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO16EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16EdgeCountPin0").as(BrickletIO16EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 0), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO16EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO16EdgeCountPin1").as(BrickletIO16EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 1), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 0)));
		this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 1)));
		this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 2)));
		this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 3)));
		this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 4)));
		this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 5)));
		this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 6)));
		this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 7)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 0)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 1)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 2)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 3)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 4)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 5)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 6)));
		this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 7)));
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.pinConfiguration0 > 1) {
                result.add("IO16InputPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO16InputPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("IO16InputPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("IO16InputPin3");
            }
		if (cfg.pinConfiguration4 > 1) {
                result.add("IO16InputPin4");
            }
		if (cfg.pinConfiguration5 > 1) {
                result.add("IO16InputPin5");
            }
		if (cfg.pinConfiguration6 > 1) {
                result.add("IO16InputPin6");
            }
		if (cfg.pinConfiguration7 > 1) {
                result.add("IO16InputPin7");
            }
		if (cfg.pinConfiguration8 > 1) {
                result.add("IO16InputPin8");
            }
		if (cfg.pinConfiguration9 > 1) {
                result.add("IO16InputPin9");
            }
		if (cfg.pinConfiguration10 > 1) {
                result.add("IO16InputPin10");
            }
		if (cfg.pinConfiguration11 > 1) {
                result.add("IO16InputPin11");
            }
		if (cfg.pinConfiguration12 > 1) {
                result.add("IO16InputPin12");
            }
		if (cfg.pinConfiguration13 > 1) {
                result.add("IO16InputPin13");
            }
		if (cfg.pinConfiguration14 > 1) {
                result.add("IO16InputPin14");
            }
		if (cfg.pinConfiguration15 > 1) {
                result.add("IO16InputPin15");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO16OutputPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO16OutputPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO16OutputPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO16OutputPin3");
            }
		if (cfg.pinConfiguration4 <= 1) {
                result.add("IO16OutputPin4");
            }
		if (cfg.pinConfiguration5 <= 1) {
                result.add("IO16OutputPin5");
            }
		if (cfg.pinConfiguration6 <= 1) {
                result.add("IO16OutputPin6");
            }
		if (cfg.pinConfiguration7 <= 1) {
                result.add("IO16OutputPin7");
            }
		if (cfg.pinConfiguration8 <= 1) {
                result.add("IO16OutputPin8");
            }
		if (cfg.pinConfiguration9 <= 1) {
                result.add("IO16OutputPin9");
            }
		if (cfg.pinConfiguration10 <= 1) {
                result.add("IO16OutputPin10");
            }
		if (cfg.pinConfiguration11 <= 1) {
                result.add("IO16OutputPin11");
            }
		if (cfg.pinConfiguration12 <= 1) {
                result.add("IO16OutputPin12");
            }
		if (cfg.pinConfiguration13 <= 1) {
                result.add("IO16OutputPin13");
            }
		if (cfg.pinConfiguration14 <= 1) {
                result.add("IO16OutputPin14");
            }
		if (cfg.pinConfiguration15 <= 1) {
                result.add("IO16OutputPin15");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO16MonoflopPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO16MonoflopPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO16MonoflopPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO16MonoflopPin3");
            }
		if (cfg.pinConfiguration4 <= 1) {
                result.add("IO16MonoflopPin4");
            }
		if (cfg.pinConfiguration5 <= 1) {
                result.add("IO16MonoflopPin5");
            }
		if (cfg.pinConfiguration6 <= 1) {
                result.add("IO16MonoflopPin6");
            }
		if (cfg.pinConfiguration7 <= 1) {
                result.add("IO16MonoflopPin7");
            }
		if (cfg.pinConfiguration8 <= 1) {
                result.add("IO16MonoflopPin8");
            }
		if (cfg.pinConfiguration9 <= 1) {
                result.add("IO16MonoflopPin9");
            }
		if (cfg.pinConfiguration10 <= 1) {
                result.add("IO16MonoflopPin10");
            }
		if (cfg.pinConfiguration11 <= 1) {
                result.add("IO16MonoflopPin11");
            }
		if (cfg.pinConfiguration12 <= 1) {
                result.add("IO16MonoflopPin12");
            }
		if (cfg.pinConfiguration13 <= 1) {
                result.add("IO16MonoflopPin13");
            }
		if (cfg.pinConfiguration14 <= 1) {
                result.add("IO16MonoflopPin14");
            }
		if (cfg.pinConfiguration15 <= 1) {
                result.add("IO16MonoflopPin15");
            }
		if (cfg.pinConfiguration0 > 1) {
                result.add("IO16EdgeCountPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO16EdgeCountPin1");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IO16InputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16InputPin"), "Input Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16InputPin")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "IO16OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16OutputPin"), "Output Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "IO16Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            case "IO16EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO16EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO16EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IO-16 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("16-channel digital input/output").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IO16InputPin0", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16InputPin1", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 1/A1").build(), new ChannelDefinitionBuilder("IO16InputPin2", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 2/A2").build(), new ChannelDefinitionBuilder("IO16InputPin3", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 3/A3").build(), new ChannelDefinitionBuilder("IO16InputPin4", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 4/A4").build(), new ChannelDefinitionBuilder("IO16InputPin5", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 5/A5").build(), new ChannelDefinitionBuilder("IO16InputPin6", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 6/A6").build(), new ChannelDefinitionBuilder("IO16InputPin7", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 7/A7").build(), new ChannelDefinitionBuilder("IO16InputPin8", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 8/B0").build(), new ChannelDefinitionBuilder("IO16InputPin9", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 9/B1").build(), new ChannelDefinitionBuilder("IO16InputPin10", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 10/B2").build(), new ChannelDefinitionBuilder("IO16InputPin11", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 11/B3").build(), new ChannelDefinitionBuilder("IO16InputPin12", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 12/B4").build(), new ChannelDefinitionBuilder("IO16InputPin13", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 13/B5").build(), new ChannelDefinitionBuilder("IO16InputPin14", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 14/B6").build(), new ChannelDefinitionBuilder("IO16InputPin15", new ChannelTypeUID("tinkerforge", "IO16InputPin")).withLabel("Input Value Pin 15/B7").build(), new ChannelDefinitionBuilder("IO16OutputPin0", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16OutputPin1", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 1/A1").build(), new ChannelDefinitionBuilder("IO16OutputPin2", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 2/A2").build(), new ChannelDefinitionBuilder("IO16OutputPin3", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 3/A3").build(), new ChannelDefinitionBuilder("IO16OutputPin4", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 4/A4").build(), new ChannelDefinitionBuilder("IO16OutputPin5", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 5/A5").build(), new ChannelDefinitionBuilder("IO16OutputPin6", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 6/A6").build(), new ChannelDefinitionBuilder("IO16OutputPin7", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 7/A7").build(), new ChannelDefinitionBuilder("IO16OutputPin8", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 8/B0").build(), new ChannelDefinitionBuilder("IO16OutputPin9", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 9/B1").build(), new ChannelDefinitionBuilder("IO16OutputPin10", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 10/B2").build(), new ChannelDefinitionBuilder("IO16OutputPin11", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 11/B3").build(), new ChannelDefinitionBuilder("IO16OutputPin12", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 12/B4").build(), new ChannelDefinitionBuilder("IO16OutputPin13", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 13/B5").build(), new ChannelDefinitionBuilder("IO16OutputPin14", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 14/B6").build(), new ChannelDefinitionBuilder("IO16OutputPin15", new ChannelTypeUID("tinkerforge", "IO16OutputPin")).withLabel("Output Value Pin 15/B7").build(), new ChannelDefinitionBuilder("IO16MonoflopPin0", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16MonoflopPin1", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 1/A1").build(), new ChannelDefinitionBuilder("IO16MonoflopPin2", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 2/A2").build(), new ChannelDefinitionBuilder("IO16MonoflopPin3", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 3/A3").build(), new ChannelDefinitionBuilder("IO16MonoflopPin4", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 4/A4").build(), new ChannelDefinitionBuilder("IO16MonoflopPin5", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 5/A5").build(), new ChannelDefinitionBuilder("IO16MonoflopPin6", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 6/A6").build(), new ChannelDefinitionBuilder("IO16MonoflopPin7", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 7/A7").build(), new ChannelDefinitionBuilder("IO16MonoflopPin8", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 8/B0").build(), new ChannelDefinitionBuilder("IO16MonoflopPin9", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 9/B1").build(), new ChannelDefinitionBuilder("IO16MonoflopPin10", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 10/B2").build(), new ChannelDefinitionBuilder("IO16MonoflopPin11", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 11/B3").build(), new ChannelDefinitionBuilder("IO16MonoflopPin12", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 12/B4").build(), new ChannelDefinitionBuilder("IO16MonoflopPin13", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 13/B5").build(), new ChannelDefinitionBuilder("IO16MonoflopPin14", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 14/B6").build(), new ChannelDefinitionBuilder("IO16MonoflopPin15", new ChannelTypeUID("tinkerforge", "IO16Monoflop")).withLabel("Monoflop Pin 15/B7").build(), new ChannelDefinitionBuilder("IO16EdgeCountPin0", new ChannelTypeUID("tinkerforge", "IO16EdgeCount")).withLabel("Edge Count Pin 0/A0").build(), new ChannelDefinitionBuilder("IO16EdgeCountPin1", new ChannelTypeUID("tinkerforge", "IO16EdgeCount")).withLabel("Edge Count Pin 1/A1").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:io16":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("pinConfiguration0", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 0/A0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 0/A0").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration1", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 1/A1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 1/A1").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration2", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 2/A2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 2/A2").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration3", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 3/A3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 3/A3").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration4", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 4/A4. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 4/A4").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration5", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 5/A5. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 5/A5").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration6", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 6/A6. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 6/A6").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration7", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 7/A7. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 7/A7").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration8", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 8/B0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 8/B0").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration9", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 9/B1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 9/B1").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration10", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 10/B2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 10/B2").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration11", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 11/B3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 11/B3").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration12", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 12/B4. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 12/B4").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration13", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 13/B5. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 13/B5").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration14", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 14/B6. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 14/B6").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration15", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 15/B7. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 15/B7").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build()));
            case "channel-type:tinkerforge:IO16InputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO16OutputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO16Monoflop":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(2147483647)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").build()));
            case "channel-type:tinkerforge:IO16EdgeCount":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        switch(value) {
            case "IO16InputPin0":
               return;
            case "IO16InputPin1":
               return;
            case "IO16InputPin2":
               return;
            case "IO16InputPin3":
               return;
            case "IO16InputPin4":
               return;
            case "IO16InputPin5":
               return;
            case "IO16InputPin6":
               return;
            case "IO16InputPin7":
               return;
            case "IO16InputPin8":
               return;
            case "IO16InputPin9":
               return;
            case "IO16InputPin10":
               return;
            case "IO16InputPin11":
               return;
            case "IO16InputPin12":
               return;
            case "IO16InputPin13":
               return;
            case "IO16InputPin14":
               return;
            case "IO16InputPin15":
               return;
            case "IO16OutputPin0": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin0Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin1": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin1Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin2": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin2Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin3": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin3Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin4": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin4Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin5": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin5Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin6": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin6Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin7": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin7Getter0(this.getPort('a'), cfg));
                   return;
               }
            case "IO16OutputPin8": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin8Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16OutputPin9": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin9Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16OutputPin10": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin10Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16OutputPin11": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin11Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16OutputPin12": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin12Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16OutputPin13": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin13Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16OutputPin14": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin14Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16OutputPin15": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO16OutputPin15Getter0(this.getPort('b'), cfg));
                   return;
               }
            case "IO16MonoflopPin0": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin0Getter0(this.getPortMonoflop('a', (short)0), cfg));
                   return;
               }
            case "IO16MonoflopPin1": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin1Getter0(this.getPortMonoflop('a', (short)1), cfg));
                   return;
               }
            case "IO16MonoflopPin2": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin2Getter0(this.getPortMonoflop('a', (short)2), cfg));
                   return;
               }
            case "IO16MonoflopPin3": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin3Getter0(this.getPortMonoflop('a', (short)3), cfg));
                   return;
               }
            case "IO16MonoflopPin4": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin4Getter0(this.getPortMonoflop('a', (short)4), cfg));
                   return;
               }
            case "IO16MonoflopPin5": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin5Getter0(this.getPortMonoflop('a', (short)5), cfg));
                   return;
               }
            case "IO16MonoflopPin6": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin6Getter0(this.getPortMonoflop('a', (short)6), cfg));
                   return;
               }
            case "IO16MonoflopPin7": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin7Getter0(this.getPortMonoflop('a', (short)7), cfg));
                   return;
               }
            case "IO16MonoflopPin8": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin8Getter0(this.getPortMonoflop('b', (short)0), cfg));
                   return;
               }
            case "IO16MonoflopPin9": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin9Getter0(this.getPortMonoflop('b', (short)1), cfg));
                   return;
               }
            case "IO16MonoflopPin10": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin10Getter0(this.getPortMonoflop('b', (short)2), cfg));
                   return;
               }
            case "IO16MonoflopPin11": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin11Getter0(this.getPortMonoflop('b', (short)3), cfg));
                   return;
               }
            case "IO16MonoflopPin12": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin12Getter0(this.getPortMonoflop('b', (short)4), cfg));
                   return;
               }
            case "IO16MonoflopPin13": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin13Getter0(this.getPortMonoflop('b', (short)5), cfg));
                   return;
               }
            case "IO16MonoflopPin14": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin14Getter0(this.getPortMonoflop('b', (short)6), cfg));
                   return;
               }
            case "IO16MonoflopPin15": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO16MonoflopPin15Getter0(this.getPortMonoflop('b', (short)7), cfg));
                   return;
               }
            case "IO16EdgeCountPin0": {
                   BrickletIO16EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16EdgeCountPin0Getter0(this.getEdgeCount((short)0, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO16EdgeCountPin1": {
                   BrickletIO16EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO16EdgeCountPin1Getter0(this.getEdgeCount((short)1, channelCfg.resetOnRead), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        switch(channel) {
            case "IO16OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 0), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 1), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 2), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 3), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin4":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 4), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin5":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 5), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin6":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 6), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin7":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 7), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin8":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 0), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin9":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 1), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin10":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 2), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin11":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 3), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin12":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 4), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin13":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 5), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin14":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 6), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16OutputPin15":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 7), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 0), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin0", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 1), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin1", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 2), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin2", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 3), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin3", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin4":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 4), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin4", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin5":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 5), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin5", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin6":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 6), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin6", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin7":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 7), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin7", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin8":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 0), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin8", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin9":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 1), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin9", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin10":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 2), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin10", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin11":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 3), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin11", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin12":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 4), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin12", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin13":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 5), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin13", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin14":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 6), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin14", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO16MonoflopPin15":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 7), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO16OutputPin15", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIO16InputPin0Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin1Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin2Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin3Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin4Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin5Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin6Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin7Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin8Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin9Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin10Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin11Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin12Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin13Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin14Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16InputPin15Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin0Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin1Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin2Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin3Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin4Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin5Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin6Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin7Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin8Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin9Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin10Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin11Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin12Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin13Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin14Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin15Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin0Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin1Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin2Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin3Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin4Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin5Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin6Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin7Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin8Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin9Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin10Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin11Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin12Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin13Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin14Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16OutputPin15Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin0Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin1Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin2Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin3Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin4Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin5Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin6Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin7Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin8Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin9Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin10Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin11Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin12Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin13Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin14Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16MonoflopPin15Getter0(PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO16EdgeCountPin0Getter0(long value, BrickletIO16Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO16EdgeCountPin1Getter0(long value, BrickletIO16Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
}
